<?php
 
 
 

namespace Google\Protobuf\Internal\FieldOptions;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBWire;
use Google\Protobuf\Internal\InputStream;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;






class FeatureSupport extends \Google\Protobuf\Internal\Message
{
    






    protected $edition_introduced = null;
    





    protected $edition_deprecated = null;
    





    protected $deprecation_warning = null;
    






    protected $edition_removed = null;

    





















    public function __construct($data = NULL) {
        \GPBMetadata\Google\Protobuf\Internal\Descriptor::initOnce();
        parent::__construct($data);
    }

    







    public function getEditionIntroduced()
    {
        return isset($this->edition_introduced) ? $this->edition_introduced : 0;
    }

    public function hasEditionIntroduced()
    {
        return isset($this->edition_introduced);
    }

    public function clearEditionIntroduced()
    {
        unset($this->edition_introduced);
    }

    








    public function setEditionIntroduced($var)
    {
        GPBUtil::checkEnum($var, \Google\Protobuf\Internal\Edition::class);
        $this->edition_introduced = $var;

        return $this;
    }

    






    public function getEditionDeprecated()
    {
        return isset($this->edition_deprecated) ? $this->edition_deprecated : 0;
    }

    public function hasEditionDeprecated()
    {
        return isset($this->edition_deprecated);
    }

    public function clearEditionDeprecated()
    {
        unset($this->edition_deprecated);
    }

    







    public function setEditionDeprecated($var)
    {
        GPBUtil::checkEnum($var, \Google\Protobuf\Internal\Edition::class);
        $this->edition_deprecated = $var;

        return $this;
    }

    






    public function getDeprecationWarning()
    {
        return isset($this->deprecation_warning) ? $this->deprecation_warning : '';
    }

    public function hasDeprecationWarning()
    {
        return isset($this->deprecation_warning);
    }

    public function clearDeprecationWarning()
    {
        unset($this->deprecation_warning);
    }

    







    public function setDeprecationWarning($var)
    {
        GPBUtil::checkString($var, True);
        $this->deprecation_warning = $var;

        return $this;
    }

    







    public function getEditionRemoved()
    {
        return isset($this->edition_removed) ? $this->edition_removed : 0;
    }

    public function hasEditionRemoved()
    {
        return isset($this->edition_removed);
    }

    public function clearEditionRemoved()
    {
        unset($this->edition_removed);
    }

    








    public function setEditionRemoved($var)
    {
        GPBUtil::checkEnum($var, \Google\Protobuf\Internal\Edition::class);
        $this->edition_removed = $var;

        return $this;
    }

}

